"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault").default;

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard").default;

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _objectSpread2 = _interopRequireDefault(require("@babel/runtime/helpers/objectSpread2"));

var _slicedToArray2 = _interopRequireDefault(require("@babel/runtime/helpers/slicedToArray"));

var _objectWithoutProperties2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutProperties"));

var _react = _interopRequireWildcard(require("react"));

var _reactDom = _interopRequireDefault(require("react-dom"));

var _jsxRuntime = require("react/jsx-runtime");

var _excluded = ["html", "css", "js", "title", "head", "onLoad"];

var _default = /*#__PURE__*/_react.default.forwardRef(function (props, ref) {
  var _props$html = props.html,
      html = _props$html === void 0 ? '' : _props$html,
      css = props.css,
      js = props.js,
      _props$title = props.title,
      title = _props$title === void 0 ? 'Demo Title' : _props$title,
      head = props.head,
      _onLoad = props.onLoad,
      other = (0, _objectWithoutProperties2.default)(props, _excluded);

  var _useState = (0, _react.useState)(false),
      _useState2 = (0, _slicedToArray2.default)(_useState, 2),
      isLoaded = _useState2[0],
      setIsLoaded = _useState2[1];

  var frameRef = (0, _react.useRef)(null);
  var srcDoc = (0, _react.useMemo)(function () {
    setIsLoaded(false);
    var jsString = js ? "<script type=\"text/javascript\">".concat(js, "</script>") : '';
    var cssString = css ? "<style>".concat(css, "</style>") : '';
    return "<!DOCTYPE html><html><head>".concat(cssString, "</head><body>").concat(html, "</body>").concat(jsString, "</html>");
  }, [css, html, js]);

  function renderFrameContents() {
    if (!frameRef.current || !frameRef.current.contentDocument || !frameRef.current.contentWindow) return null;
    return [/*#__PURE__*/_reactDom.default.createPortal(head, frameRef.current.contentDocument.head)];
  }

  return /*#__PURE__*/(0, _jsxRuntime.jsx)("iframe", (0, _objectSpread2.default)((0, _objectSpread2.default)({
    title: title,
    width: "100%",
    height: "100%",
    style: {
      border: 0
    }
  }, other), {}, {
    onLoad: function onLoad(evn) {
      setIsLoaded(true);
      _onLoad && _onLoad(evn);
    },
    ref: frameRef,
    srcDoc: srcDoc,
    children: isLoaded && renderFrameContents()
  }));
});

exports.default = _default;
module.exports = exports.default;
//# sourceMappingURL=index.js.map